

import java.net.Socket;
import java.net.ServerSocket;
import java.io.*;
import java.util.*;
import servizi.*;


public class GestRichieste extends Thread{


	private ServiceHash serviceh;
	private Servizio ServTemp;
	private ObjectInputStream datain;
	private ObjectOutputStream dataout;
	private String comando;
	private String argomenti;
	
	private Connessione mySock;
	private int myId;
	private Gestore_Connessione gest;
	
	
	public	GestRichieste(Connessione m, int Id,Gestore_Connessione gest,ServiceHash sh){
		serviceh = sh;
		//theSocket = sk;
		this.gest = gest;
		mySock = m;
		myId = Id;
		ServTemp = null;
		comando = null;
	}
	public	GestRichieste(Gestore_Connessione gest,ServiceHash sh,Servizio serx) {
		serviceh = sh;
		this.gest = gest;
		mySock = null;
		myId = 0;
		ServTemp = serx;
		comando = null;
	}
	public	GestRichieste(Gestore_Connessione gest,ServiceHash sh,String stx,String argx,Servizio serx) {
		serviceh = sh;
		this.gest = gest;
		mySock = null;
		myId = 0;
		ServTemp = serx;
		comando = stx;
		argomenti = argx;
	}
	public	GestRichieste(Gestore_Connessione gest,ServiceHash sh,String stx) {
		serviceh = sh;
		this.gest = gest;
		mySock = null;
		myId = 0;
		ServTemp = null;
		comando = stx;
		argomenti = null;
	}
	public void run() {
		if(comando!=null) {
			if(ServTemp!=null) {
				//gestisce comando da terminale
				Servizio sv = ServTemp.mioClone();
				sv.nuovoGest(this);
				sv.rispostaTerminale(comando,argomenti);
			}else {
				//gestisce evento
				gestioneEvento(comando);
			}
			
		}else {
			if(ServTemp!=null) {
				//gestisce autoesecuzione
				Servizio sv = ServTemp.mioClone();
				sv.nuovoGest(this);
				sv.autoEsegui();
			}else {
				//gestisce richiesta remota
				try {
					while (processRequests())
					yield(); // yield to other threads too!
					mySock.cleanUp();
				} catch (IOException E){
					System.out.println("Error in processing request");
				}
			}
		}
	}
	private boolean processRequests() throws IOException {
		Object req;
		boolean criptato = false;
		try {
			System.out.println(" processore richieste attivato");
			mySock.leggicriptato();
			
			req = mySock.leggi();
			
		} catch(Exception e) {
			System.out.println("Errore processRequests"+e.getMessage());
			return false;
		}
		String reqx;
		String ret;
		try {
			reqx= (String) req;
			System.out.println("richiesta : "+reqx);
			if(req==null) {
				System.out.println("gestione del criptaggio part 1 ");
				ret = attivaEvento("Client",null,mySock);
				System.out.println("richiesta processata : Client evento : "+ret);
				return false;	
			}
		} catch(Exception e) {
			System.out.println("gestione del criptaggio particolare "+e.getMessage());
			ret = attivaEvento("Client",null,mySock);
			System.out.println("richiesta processata : Client evento : "+ret);
			return false;
		}	
		
		ret = attivaEvento(reqx,null,mySock);
		System.out.println("richiesta processata : "+reqx+" evento : "+ret);
		return false;
		
	}
	
	public String attivaEvento(String nomeserv,Object arg,Connessione s) {
		//System.out.println("attivaEvento "+nomeserv);
		Servizio sv = serviceh.richiedi2(nomeserv);
		String ev,n,evento;
		if (sv == null) {
			n = "ServHash";
			ev = "nondispo";
			
		} else {
			sv.nuovoGest(this);
			ev = sv.rispondi(nomeserv,arg,s);	
			n = sv.nome();
		}
		evento = n+"-"+nomeserv+"-"+ev;
		//System.out.println("attiva risponde "+evento);
		gestioneEvento(evento);
		return evento;
		
	}
	public void gestioneEvento(String evento) {
		//System.out.println("gestisco evento "+evento);
		Servizio sv = serviceh.richiediEvento2(evento);
		if (sv != null) {
			//System.out.println("gestisco evento risponde"+sv.nome());
			sv.nuovoGest(this);
			String h = sv.gestEventi(evento);	
			if(h != null) {if(!h.equals("")) gestioneEvento(sv.nome()+"-Evento-"+h);}
			
		}
		
	}
	public String attiva(String nomeserv,Object arg,Connessione s) {
		System.out.println("attiva "+nomeserv);
		Servizio sv = serviceh.richiedi2(nomeserv);
		String ev;
		if (sv == null) {
			ev = "nondispo";
			
		} else {
			sv.nuovoGest(this);
			ev = sv.rispondi(nomeserv,arg,s);	
			
		}
		System.out.println("attiva risponde "+ev);
		return ev;
		
	}
	public String attivaTerminale(String serviz,String comando,String arg) {
		
		
		System.out.println("attivaTerminale "+serviz+"-"+comando+"-"+arg);
		Servizio ServTemp = serviceh.richiediServ(serviz);
		String rit;
		if(ServTemp == null) {
			rit = "NonTrovato";
		}else {
			Servizio sv = ServTemp.mioClone();
			sv.nuovoGest(this);
			rit = sv.rispostaTerminale(comando,arg);
			
		}
		return rit;
		
	}
}