

import java.net.*;
import java.io.*;
import java.util.*;
import iaik.utils.CryptoUtils;
import iaik.security.provider.IAIK;
import iaik.security.rsa.*;
import java.security.*;
import MyCertificate;

public class Gestore_Connessione {
	
	private final int Dominio_non_Trovato = 0;
	private final int User_non_Riconosciuto = 1;
	private final int User_Disabilitato = 2;
	private final int User_Bloccato = 3;
	public boolean verbose;
	private String myport;
       	private String myip;
	private int n_threads;
	private MyCertificate myCert;
	private RSAPrivateKey prk;
	private String dominio;
	String fconfig;  //  nome file configurazione
	RandomAccessFile f; //  file configurazione
	private boolean fine;
	private ServerSocket ServSock;
	private Hashtable MemAgent;
	//public void dump() { System.out.println(domini.toString());}
	public Gestore_Connessione() {  }
       	
	public ServerSocket inizializza(String fconf) {
		
		try {		
			fconfig = fconf;
			
			f = new RandomAccessFile(fconfig,"r");	
			if(trova("verbose").equalsIgnoreCase("true")) verbose = true;
			else verbose = false;
			System.out.println("verbose : "+verbose);
			n_threads = Integer.parseInt(trova("n_threads"));
			
			myport = trova("myport");
			
			myip = InetAddress.getLocalHost().getHostAddress();
			
			System.out.println("indirizzo ip : "+myip);
			dominio = trova("dominio");			
			prk = (RSAPrivateKey) carica("private key");
			if(prk==null) System.out.println("chiave privata non caricata");
			myCert = (MyCertificate) carica("certificato");
			RSAPublicKey p = (RSAPublicKey) myCert.getPublicKey();
			if(myCert==null) System.out.println("certificato non caricato");
			else System.out.println(p.toString());
						
						
			
			ServSock = new ServerSocket(getIntPort());
			fine = false;
			
			MemAgent = new Hashtable();
			
			System.out.println("Server in attesa su Porta : "+myport);
			
			return ServSock;
			
		} catch (Exception E) {System.out.println("configura : "+E.getMessage()); return null;}
		
	}
	public synchronized void memPut(Object obj,String id,String chiave) {
		if(MemAgent.containsKey(id)) {
			Hashtable h = (Hashtable) MemAgent.get(id);
			h.put(chiave,obj);
		}
		else {
			Hashtable h  = new Hashtable();
			h.put(chiave,obj);
			MemAgent.put(id,h);	
		}
	}
	public synchronized Object memGet(String id,String chiave) {
		if(MemAgent.containsKey(id)) {
			Hashtable h = (Hashtable) MemAgent.get(id);
			return (Object) h.get(chiave);
		} else return null;
	}
	public synchronized void memRst(String id) {
		MemAgent.remove(id);
	}
	public boolean fine() {	return fine; }
	public void termina () throws IOException
		{ fine=true;ServSock.close(); }
	
	
	/*   PROVA   per caricare dinamicamente la configurazione dei servizi*/
	public Object carica(String nome) {
		try {	
			RandomAccessFile f = new RandomAccessFile(fconfig,"r");
			String h = trova(nome);
			return caricaFile(h);
		} catch (Exception e) {
			System.out.println("carica error : "+e.getMessage());
			return null;
		}	
	}
	public Object caricaFile(String nomefile) {
		try {	
			Object ret;
			FileInputStream fis = new FileInputStream(nomefile);
        		ObjectInputStream ois = new ObjectInputStream(fis);
			ret = ois.readObject();
			fis.close();
			return ret;
		} catch (Exception e) {
			System.out.println("caricaFile error : "+e.getMessage());
			return null;
		}	
	}
	public String trova(String termin) {
		try {
			String termine = termin.toUpperCase();
			long len = f.length();
			f.seek(0);
			String temp,tempU;
			while(f.getFilePointer()<len ) {
				temp = f.readLine();
				tempU = temp.toUpperCase();
				int j = tempU.indexOf(termine);
				if (j!=-1) {
					int h1 = tempU.indexOf('[',j);
					int h2 = tempU.indexOf(']',j);
					String temp2 = temp.substring(h1+1,h2);
					
					return temp2.trim();
				}
			}
		}
		catch(Exception e)
		{System.out.println("trova : "+e.getMessage()); return "";}
		return "";
	}
		
	/*   PROVA   */

	
	
	/*
	private int Dominio_non_Trovato = 0;
	private int User_non_Riconosciuto = 1;
	private int User_Disabilitato = 2;
	private int User_Bloccato = 3;
	*/
	
	public String getMe() {
		return myip.concat(":"+myport);
	}
	public String dominio() {
		return dominio;
	}
	
	
	public int getIntPort() {
		return Integer.parseInt(myport);
	}
	public String getStringPort() {
		return myport;
	}
	public String getIp() {
		return myip;
	}
	
	public RSAPrivateKey getPrivateKey() {
		return prk;
	}
	public RSAPublicKey getPublicKey() {
		return (RSAPublicKey) myCert.getPublicKey();
	
	}
	public MyCertificate getCertificate() {
		return myCert;
	
	}
	
	
	public int getThreads() {
		return n_threads;
	}
	
	public String[] trovatutti(String termin) {
		try {
			Vector result = new Vector();
			String termine = termin.toUpperCase();
			long len = f.length();
			int j;
			f.seek(0);
			String temp,tempU;
			while(f.getFilePointer()<len ) {
				temp = f.readLine();
				tempU = temp.toUpperCase();
				j = tempU.indexOf(termine);
				if (j!=-1) {
					int h1 = tempU.indexOf('[',j);
					int h2 = tempU.indexOf(']',j);
					String temp2 = temp.substring(h1+1,h2).trim();
					if(!temp2.equals("")) result.add(temp2);
					
				}
			}
			int num = result.size();
			String[] res = new String[num];
			result.copyInto(res);
			return res;
			
		}
		catch(Exception e) {
			System.out.println("errore trovatutti : "+e.getMessage());
			return null;
		}
		
	}
	
	
	/*	
	Dominio_non_Trovato = 0;
	User_non_Riconosciuto = 1;
	User_Disabilitato = 2;
	User_Bloccato = 3;
	Erro0 :Cache dominio non trovato
	
	Erro1 :Cache utente non riconosciuto
	
	Erro2 :Cache utente non abilitato
	
	Erro3 :cache utente bloccato nella cache l' utente  bloccato
	
	Erro4 :Mittente non riconosciuto  il server da cui arriva la richiesta di relog non  riconosciuto
	
	Erro5  Utente inesistente  non c' la chiave publica utente nel vettore delle chiavi
	
	
	
	
	Erro6 Slave Server non riconosciuto
	
	Erro7 super server non rispondono
	*/	
		
		
		
		
		/* inserisce domini dei server slsve */
	
	/*
	public String manda(mySocket sock,String msg) {
		return manda(msg);
	
	}
	public String manda(mySocket sock,String dom,String msg) {
		return manda(dom,msg);
	}
	*/
	
}