
import java.security.*;
import java.security.cert.*;
import iaik.security.dsa.*;
import iaik.security.rsa.*;
import java.util.*;
import java.io.*;


public class MyCertificate implements Serializable {
	
	private String alias;
	private String addr;
	private RSAPublicKey rsaPubblicKey;
	private String certNome;
	private String cert;
	private byte[] firma;
	
	public MyCertificate(){
		firma = null;	
		alias = null;
		addr = null;
		rsaPubblicKey = null;
		cert = null;
		certNome = null;	
	}
	public void crea(RSAPrivateKey rsaPrivateKey,RSAPublicKey pk,String nome,String ind,String certAddr,String certAlias) throws Exception {
		cert = certAddr;
		certNome = certAlias;
				
		Signature md5_rsa = Signature.getInstance("MD5/RSA", "IAIK");
 		md5_rsa.initSign(rsaPrivateKey); 
		md5_rsa.update(nome.getBytes());
		md5_rsa.update(ind.getBytes());
		md5_rsa.update(pk.getFingerprint());
		md5_rsa.update(cert.getBytes());
		md5_rsa.update(certNome.getBytes());
		
 		firma = md5_rsa.sign();
 		rsaPubblicKey = pk;
 		alias = nome;
 		addr = ind;
 		
 
		
	}
	public void verify(RSAPublicKey rsaPublicKey) throws CertificateException,
                            				NoSuchAlgorithmException,
                            				InvalidKeyException,
                            				NoSuchProviderException,
                            				SignatureException {
		Signature md5_rsa = Signature.getInstance("MD5/RSA", "IAIK");
		md5_rsa.initVerify(rsaPublicKey);
		md5_rsa.update(alias.getBytes());
		md5_rsa.update(addr.getBytes());
		md5_rsa.update(rsaPubblicKey.getFingerprint());
		md5_rsa.update(cert.getBytes());
		md5_rsa.update(certNome.getBytes());
		
		if(!md5_rsa.verify(firma)) throw new SignatureException();
		else System.out.println("cert ok");
		
		
	}
	public String getCertAlias() {
		return certNome;
	}
	public String getCertAddr() {
		return cert;
	}
	public String getAlias() {
		return alias;
	}
	public String getAddress() {
		return addr;
	}
	
	
	public byte[] getEncoded() {
		return firma;
	}
         
	public PublicKey getPublicKey() {
		return rsaPubblicKey;
	}
         
 
	public String toString() {
		return "firma :"+addr+" "+alias;
		
	}
         
	
}