
import java.security.*;
import java.security.cert.*;
import iaik.security.dsa.*;
import iaik.security.rsa.*;
import java.util.*;
import java.io.*;


public class MyKeyStore implements Serializable {
	

	
	private Hashtable cer_alias;
	private Hashtable cer_addr;
	private Hashtable cer_firma;
	
	private Hashtable pri_alias;
	private Hashtable pri_addr;
	
	
	private RSAPublicKey certificatorePubblicKey;
	
	public MyKeyStore(RSAPublicKey puk){
		cer_alias = new Hashtable();
		cer_addr = new Hashtable();
		pri_alias = new Hashtable();
		pri_addr = new Hashtable();
		cer_firma = new Hashtable();
		certificatorePubblicKey = puk;
	}
	public boolean carica(String nomeFile, String password){
		
		try {
			
			FileInputStream fis = new FileInputStream(nomeFile);
	        		System.out.println("caricaFile 2");
	        	ObjectInputStream ois = new ObjectInputStream(fis);
				System.out.println("caricaFile 3");
			
			cer_alias = (Hashtable) ois.readObject();
			cer_addr = (Hashtable) ois.readObject();
			pri_alias = (Hashtable) ois.readObject();
			pri_addr = (Hashtable) ois.readObject();
			certificatorePubblicKey = (RSAPublicKey) ois.readObject();
			fis.close();
			return true;
		} catch (Exception e){
			cer_alias = new Hashtable();
			cer_addr = new Hashtable();
			pri_alias = new Hashtable();
			pri_addr = new Hashtable();
			return false;
		
		}	
		
	}
	
	public boolean add(PrivateKey prk,String alias,String addr) throws Exception  {
		boolean res = true;
		if(pri_alias.containsKey(alias)) res = false;
          	if(pri_addr.containsKey(addr)) res = false;
		if(res) {
			pri_alias.put(alias,prk);
			pri_addr.put(addr,prk);
			return true;
		} else return false;
		
 	}
 	
 	
	public boolean add(MyCertificate cert) throws Exception  {
		boolean res = true;
		String alias = cert.getAlias();
		String addr = cert.getAddress();
		byte[] firma = cert.getEncoded();
		if(cer_alias.containsKey(alias)) res = false;
		if(cer_addr.containsKey(addr)) res = false;
          	if(cer_firma.containsKey(new String(firma))) res = false;
		if(res) {
			cer_alias.put(alias,cert);
			cer_addr.put(addr,cert);
			cer_firma.put(new String(firma),cert);
			return true;
		} else return false;
		
 	}
 	public void deleteCertificateByAddr(String addr) {
 		cer_addr.remove(addr);
 		
 		
 		
 	}
 	
	public MyCertificate getCertificateByAddr(String addr) {
		return (MyCertificate) cer_addr.get(addr);
	
	}
	public MyCertificate getCertificateByFirma(byte[] firma) {
		return (MyCertificate) cer_firma.get(new String(firma));
	
	}
	public MyCertificate getCertificateByName(String alias) {
		return (MyCertificate) cer_alias.get(alias);
	
	}
	public PublicKey getPublicKeyByAddr(String addr) {
		MyCertificate cer = (MyCertificate) cer_addr.get(addr);
		if(cer!=null) return cer.getPublicKey();
		else return null;
	}
	public PublicKey getPublicKeyByName(String alias) {
		MyCertificate cer = (MyCertificate) cer_alias.get(alias);
		if(cer!=null) return cer.getPublicKey();
		else return null;
	}
	public PrivateKey getPrivateKeyByAddr(String addr) {
		return (RSAPrivateKey) pri_addr.get(addr);
	
	}
	public PrivateKey getPrivateKeyByName(String alias) {
		return (RSAPrivateKey) pri_alias.get(alias);
	
	}
	
         


}