package servizi;

import java.sql.*;
import java.net.*;
import java.io.*;
import java.awt.*;

import java.util.*;
import iaik.security.rsa.*;
import java.security.*;
import java.security.spec.*;


import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;
import Gestore_Connessione;
import ServiceHash;
import Connessione;
import MultiConnessione;
import Cache;
import Firma;
import MyCertificate;
import MyKeyStore;
import Cript;

public class ServConn extends Servizio {
	private final int Dominio_non_Trovato = 0;
	private Hashtable domini;
	//private Hashtable pkey;	  /*  memorizzate le chiavi pubbliche dei server */
	private	MyKeyStore ks;
	private RSAPublicKey certkey;
	private String certAddr;
	private Vector s_server; /*  memorizzati come [Ip:Port]  */
	private String dominio;
	//private int mil_ntrovato;
	//private Cache nt_dom_cache; /*  domini non trovati */
	private String address;
	private String ks_nome;
	private String bakfile;
	private boolean muto;
	
	public ServConn() {
		super();
		muto = false;
		descrizione = "Servizi di connessione";
		nome = "ServConn";
		servizi = new String[9];
		
		//servizi[0] = "Relog";
		servizi[0] = "Pubbl";
		servizi[1] = "Conn";
		servizi[2] = "MultiConn";
		servizi[3] = "verificaFirma";
		servizi[4] = "verificaCertificato";
		servizi[5] = "DesConn";
		servizi[6] = "ConnDominio";
		servizi[7] = "ConnSuper";
		servizi[8] = "Reque";
		
		servTerm = new String[2];
		servTerm[0] = "slaveServer ,, mostra slave server";
		servTerm[1] = "superServer ,, mostra super server";
		
		eventi = new String[1];
		eventi[0] = "ServMirror-CreaMir-MirrorCreato-1";
		
	}
	public String gestEventi(String ev) {
		if(ev.startsWith("ServMirror-CreaMir-MirrorCreato-")) {
			String ser  = ev.substring(32);
			if(gest.verbose) System.out.println("gestev : "+ser);
			cancServer(ser);
			
		}
		return ev;
		
	}
	//metti a posto gli eventi
	public String risposta(String nomeserv,Object arg) {
	
		
		
		// RIMETTERE if (nomeserv.equals("Pubbl")&&RSAcriptato) {
		if (nomeserv.equals("Pubbl")&&firmato) {
			if(gest.verbose) System.out.println("Pubbl");
			return GetPubbl();
		}			
		if (nomeserv.equals("Reque")&&firmato) {
			if(gest.verbose) System.out.println("Reque");
			
			int len = domini.size();
			String[] arrdom = new String[len+1];
			int i = 1;
			arrdom[0] = gest.dominio();
			for (Enumeration u = domini.keys() ; u.hasMoreElements() ;) {
				arrdom[i] = (String)u.nextElement();
				i++;
			}			
			
			SetPubbl(arrdom,gest.getMe());
		}	
		if (nomeserv.equals("Conn")&&argomenti) {
			try {
				if(!mySock.stato()) {
					
					RSAPublicKey puk = (RSAPublicKey) ks.getPublicKeyByAddr((String)arg);
					mySock.inizio((String)arg,puk,gest.getPrivateKey());
					mySock = null;//vedi se funziona
					return "Attivata-"+(String) arg;
				} else return "nonAttivata-"+(String) arg;
			} catch(Exception e) {
				return "ServerNonValido";
			}
			
		}
		if (nomeserv.equals("ConnDominio")&&argomenti) {
			if(gest.verbose) System.out.println("ConnDominio mysock "+mySock.stato()+" argomenti "+(String) arg);
			String dom;
			try {
				dom = (String)arg;
			} catch(Exception e) {
				if(gest.verbose) System.out.println("ArgomentoNonValido"+arg);
				return "ArgomentoNonValido";
			}	
			if(!mySock.stato()) {
				Vector v_serv = (Vector) domini.get(dom);
				if(v_serv == null) return "nonAttivata-"+dom;
				int len = v_serv.size();
				for(int i =0;i<len;i++) {

					RSAPublicKey puk = (RSAPublicKey) ks.getPublicKeyByAddr((String)v_serv.get(i));
					mySock.inizio((String)v_serv.get(i),puk,gest.getPrivateKey());
					if(mySock.stato()) {
						if(gest.verbose) System.out.println("connessione ConnDominio "+((String)v_serv.get(i))+" attivata");
						return "Attivata-"+dom;
					}
				}
				return "nonAttivata-"+dom;
			} else return "nonAttivata-"+dom;
			
			
		}
		if (nomeserv.equals("ConnSuper")&&argomenti) {
			if(gest.verbose) System.out.println("ConnSuper");
			if(!mySock.stato()) {
				int len = s_server.size();
				for(int i =0;i<len;i++) {
				
					RSAPublicKey puk = (RSAPublicKey) ks.getPublicKeyByAddr((String) s_server.get(i));
					mySock.inizio((String)s_server.get(i),puk,gest.getPrivateKey());
					if(mySock.stato()) {
						return "Attivata-"+(String)s_server.get(i);
					}
				}
				return "nonAttivata-";
			} else return "nonAttivata-";
			
			
		}
		
		if (nomeserv.equals("DesConn")&&argomenti) {
			try {
				if(!mySock.stato()) {
					Object[] aaa = (Object[]) arg;
					SecretKey sk = (SecretKey) aaa[0]; 
					String server = (String) aaa[1];
					
					mySock.inizio(sk,server);
					mySock = null;//vedi se funziona
					return "Attivata-"+server;
				} else return "nonAttivata";
			} catch(Exception e) {
				return "ServerNonValido";
			}
			
		}
		if (nomeserv.equals("MultiConn")&&(!connesso)) {
			try {
				return connettiFigli((MultiConnessione) arg);
				//System.out.println("Multiconn attiva numero "+((MultiConnessione) arg).size());
				//return "Attivata";
			} catch(Exception e) {
				 if(gest.verbose) System.out.println("multiconn nonAttivata "+e.getMessage());
				 return "nonAttivata";
				 
			}
			
			
		}
		if (nomeserv.equals("verificaFirma")&&argomenti) {
			Firma firma;
			RSAPublicKey pukx;
			try {
				firma = (Firma)arg;
			} catch(Exception e) {
				return "ArgomentoNonValido";
			}
			try {				
				pukx = (RSAPublicKey) ks.getPublicKeyByAddr(firma.getUser());
				if(pukx==null) return "UserNonRiconosciuto";
			} catch(Exception e) {
				return "UserNonRiconosciuto";
			}	
		
			if(verificaFirma(firma,pukx)) return "Valida-"+firma.getUser();
			else return "NonValida";
	
		}	
		if (nomeserv.equals("verificaCertificato")&&argomenti) {
			MyCertificate cert;
			
			try {
				cert = (MyCertificate) arg;
			} catch(Exception e) {
				return "ArgomentoNonValido";
			}
					
			if(verificaCertificato(cert)) return "Valido-"+cert.getAddress();
			else return "NonValido";
	
			
		}		
		 
	    
		return "0";
	}	
	public String rispostaTerminale(String nomeserv,String arg) {
		if(nomeserv.equals("slaveServer")) {
			System.out.println("slaveServer : "+domini); // togli
			String ret = "";
			for (Enumeration e = domini.keys() ; e.hasMoreElements() ;) {
				String val =(String) e.nextElement();
				ret = ret.concat(val+"  ");
		        	Vector s = (Vector) domini.get(val);
		        	if(s!=null) {
		        		int len = s.size();
		        		for (int i=0;i<len;i++) 
		        			ret = ret.concat((String) s.get(i)+",");
		        		
		        	}
		         	ret = ret.concat("\n");
	 		}
			if(ret.equals("")) return "Non ho slave";	
			else return ret;
		
		
		}
		if(nomeserv.equals("superServer")) {
			String ret = "";
			int len = s_server.size();
			for(int i = 0; i<len ; i++) {
				ret = ret.concat(((String) s_server.get(i))+"\n");
			}
			if(ret.equals("")) return "Non ho super server";	
			else return ret;
		}
		
		return null;
	}
	private void richiediDomini(Hashtable dom) {
		if(gest.verbose) System.out.println("Richiedi domini"); 
		Vector figli = new Vector();
		//Hashtable hdom = sc.getServer();
		int i,len,len1,h;
		String ser;
		boolean ce;
		for (Enumeration u = dom.keys() ; u.hasMoreElements() ;) {
			String g = (String)u.nextElement();
	         		Vector v = (Vector) dom.get(g);
	         		len = v.size();
	         		for(i=0;i<len;i++) {
	         			len1=figli.size();
	         			ser = (String) v.get(i);
	         			ce = false;
	         			for(h=0;h<len1;h++) if(ser.equals(figli.get(h))) ce = true;
	         			if(!ce) { figli.add(ser);
	         				System.out.println("figlio : "+ser); // togli
	         			}
	         		}
         		}
		len1=figli.size();
	         	len = len1;
	         	if(gest.verbose) System.out.println("figli"+figli); // togli
	         	//iaik.utils.Util.waitKey();
	         	String server;
	         	for(i = 0;i<len1;i++) {
	         		try {
		         		server = (String)figli.get(i);
				//Connessione con = new Connessione();
				Connessione con = new Connessione(server,null,gest.getPrivateKey(),gest.getMe());
				//con.inizio (server);
				con.firma(gest.getMe());         		
				if(con.stato()) {
					con.manda("Reque");	
					con.mandachiaro();					
					if(gest.verbose) System.out.println("Mandato Reque a "+server); 
				} else {
					if(gest.verbose) System.out.println("Non Mandato Reque a "+server); 	
				}
		         		
		         	} catch (Exception e) { 
		         		
		         		if(gest.verbose) System.out.println("Prova non attivo Mandato Reque"); 
		         		
		         		}
	         		
	         	}

	
	}
	private String salvaDomini() {
		try {
			System.out.println("salvaDomini "+domini);
			byte[] oo = Cript.ObjToByte(domini);
			oo = Cript.cripta(oo,gest.getPrivateKey());
			FileOutputStream ostream1 = new FileOutputStream(bakfile);
			ObjectOutputStream p1 = new ObjectOutputStream(ostream1);
			p1.writeObject(oo);
			p1.flush();
			ostream1.close();
			return "Salvato";
		} catch(Exception e) {
			
			return "NonSalvato";	
		}	
	}	
	public void rimuovi() {
		// da ridefinire se la rimozione prevede cose particolari
		
	}
	// ripristina prevede serializzazione anche di oggetti
	public void inizializza(Gestore_Connessione g,ServiceHash sh) {
		// da ridefinire se la serializzazione prevede cose particolari
		inizializza_p(g,sh);
		try {		
			if(gest.trova(nome+".MUTO").equalsIgnoreCase("true")) muto = true;
			domini = new Hashtable();
			address = gest.getMe();
			certkey = (RSAPublicKey) gest.carica(nome+".PublicKey certificatore");
			if (certkey!=null) if(gest.verbose) System.out.println("chiave pubblica certificatore caricata");
			
			ks_nome = gest.trova(nome+".keystore");
			if(!ks_nome.equals("")) {
				ks = (MyKeyStore) gest.caricaFile(ks_nome);
			}
			else {
				ks_nome = "keystore.ks";
				ks = new MyKeyStore(certkey);	
			}
			String certificatore = gest.trova(nome+".certificatore");
			int h1 = certificatore.indexOf('|');
			if( h1!= -1) {
				certAddr = certificatore.substring(0,h1).trim();
				String temp2 = certificatore.substring(h1+1).trim();
				MyCertificate xxx = (MyCertificate) gest.caricaFile(temp2);
				if (xxx!=null) {
					if(!certAddr.equals(xxx.getAddress())) System.out.println("indirizzo certificatore non coerente");
					ks.add(xxx);
					
				}
				
			}
			s_server = new Vector();
			String[] lisServer = gest.trovatutti(nome+".superserver");
			int len = java.lang.reflect.Array.getLength(lisServer);
			if(gest.verbose) System.out.println("numero super server trovati : "+len);
			for(int i =0;i<len;i++) {
				h1 = lisServer[i].indexOf('|');
				if( h1!= -1) {
					String temp1 = lisServer[i].substring(0,h1).trim();
					String temp2 = lisServer[i].substring(h1+1).trim();
					MyCertificate xxx = (MyCertificate) gest.caricaFile(temp2);
					if(xxx != null ) {
						if(temp1.equals(xxx.getAddress())) {						
							if(gest.verbose) System.out.println("verifica di : "+xxx.getAddress()+" "+verificaAlCertificatore(xxx));
							if(ks.add(xxx)) {
								s_server.add(temp1);
								if(gest.verbose) System.out.println("aggiunto "+temp1);
							} else if(gest.verbose) System.out.println("non aggiunto "+temp1);
						}
						else if(gest.verbose) System.out.println("non aggiunto "+temp1+" <> "+xxx.getAddress());
					}
					
				}
				
			}
					
			dominio = gest.dominio();
			if(gest.verbose) System.out.println("dominio : "+dominio);
			//verificaCertificato(gest.getCertificate());
			//System.out.println("cert ver");
       			bakfile = gest.trova(nome+".file domini");
			byte[] ooo = (byte[]) gest.carica(nome+".file domini");
       			if(ooo != null) {
				
				try {
					ooo = Cript.decripta(ooo,gest.getPublicKey());
					Hashtable dominibak = (Hashtable) Cript.ByteToObj(ooo);
					richiediDomini(dominibak);
					System.out.println("file domini ripristinato");
				}
				catch(Exception e) {
					System.out.println("file domini CORROTTO : ripristino vuoto");
					iaik.utils.Util.waitKey();
					
				}
				
			}
       			
			
		} catch (Exception E) {if(gest.verbose) System.out.println("configura : "+E.getMessage());}
		
	}
	public void prepTrasporto() {
		
		
		azzera_p();
		
		//mil_ntrovato = 0;

		//nt_dom_cache = null;

		domini = null;
		
		//pkey = null;
		//s_server = null;
		//dominio = null;
	
		
		
		
	}
	public void riprTrasporto(Gestore_Connessione g,ServiceHash sh) {
		// serve per ripristinare il Servizio dal trasporto
		// da ridefinire se il ripristino prevede cose particolari
		inizializza_p(g,sh);
		//metto a posto : passa da slave a master
		//nt_dom_cache = new Cache(mil_ntrovato);
		
		
		
		
	}
	public Object vendi() {
		// da ridefinire se il mirroring prevede cose particolari
		Object[] ret = new Object[4];
		ret[0] = ks;
		ret[1] = domini;
		ret[2] = gest.getMe();
		ret[3] = dominio;
		//ret[4] = s_server;
		return ret;
		
	}
	public void compra(Object o) {
		// da ridefinire se il mirroring prevede cose particolari
		
		try {
			Object[] acq = (Object[]) o;
			MyKeyStore ks1 = (MyKeyStore) acq[0];
			Hashtable domini1 = (Hashtable) acq[1];
			String vecc = (String) acq[2];
			String dominio1 = (String) acq[3];
			
			MyKeyStore ks2 = ks1;
			ks = ks1;
			
			Hashtable domini2 = domini;
			domini = domini1; 
			String dominio2 = dominio;
			dominio = dominio1;
			/*
			Vector v_serv = (Vector) domini.get(dominio2);
			if(v_serv == null) v_serv = new Vector();
			v_serv.add(vecc);
			
			domini.put(dominio1,v_serv);
			*/
			cancSserver(address);
			address = null;
		} catch(Exception e) {
			if(gest.verbose) System.out.println("errore in compro");
		}	
			
		
	}
	public String autoEsegui() {
		int i = domini.size();
		String dom[] = new String[i+1];
		int h=0;
		for (Enumeration u = domini.keys() ; u.hasMoreElements() ;) {
			
	         		dom[h] = (String)u.nextElement();
	         		h++;
	         		
	         	}
	         	dom[h]=dominio;
		SetPubbl(dom,gest.getMe());
		return " aaa";
		
	}
	public void azzera() {
		// da ridefinire se la serializzazione prevede cose particolari
		azzera_p();
		//mil_ntrovato = 0;

		//nt_dom_cache = null;

		domini = null;
		ks = null;
		s_server = null;
		dominio = null;

	
	}	
	private void cancServer(String ser) {
		for (Enumeration e = domini.keys() ; e.hasMoreElements() ;) {
			String val =(String) e.nextElement();
	        	Vector s = (Vector) domini.get(val);
	        	if(s!=null) {
	        		s.remove(ser);
	        		if(s.size()==0) domini.remove(val);
	        		else domini.put(val,s);
	        		
	        	}
	         		
 		}
 		try {
 			ks.deleteCertificateByAddr(ser);
 		} catch(Exception e) {
 			
 			
 		}	
 		
			
	}
	
	

	private void cancSserver(String ser) {
		s_server.remove(ser);
		try {
 			ks.deleteCertificateByAddr(ser);
 		} catch(Exception e) {
 			
 			
 		}
	}
	private void addSserver(Vector s_serv) {
		int len = s_serv.size();
		for(int i = 0; i<len ; i++) {
			s_server.add(s_serv.get(i));
		}
	}
	/*	
	private RSAPublicKey getServer(String val) {
		
		return (RSAPublicKey) pkey.get(val);
			
	}
	*/
	/*
	public Hashtable getServer() {
		return domini;
		
	}
	public Vector gets_server() {
		return s_server;
	}
	
	public boolean DominioPresente(String dom) {
		Vector v_serv = (Vector) domini.get(dom);
		return (v_serv == null) ? false : true;
	}
	public Hashtable getPublicKeys() {
		return pkey;
	}
	*/
	/*
	private String getCache(int tipo,String val1,String val2) {
		
		return getCache(tipo,val1.concat(":"+val2));
		
	}
	
	private String getCache(int tipo,String val) {
		

		switch(tipo) {
			case (Dominio_non_Trovato) : return (String) nt_dom_cache.get(val); //dominio non trovato	
			//case (User_non_Riconosciuto) : return (String) nr_usr_cache.get(val);
			//case (User_Disabilitato) : return (String) na_usr_cache.get(val);
			//case (User_Bloccato) : return (String) b_usr_cache.get(val);
		}

		return null;
			
	}
	*/	
	private synchronized void insert(String[] dom,MyCertificate cer) {
	
		int len =java.lang.reflect.Array.getLength(dom);
		String server = cer.getAddress();
		
		for(int i = 0; i < len ;i++) {
			//String t =dom[i];
			Vector v_serv = (Vector) domini.get(dom[i]);
			if(v_serv == null) v_serv = new Vector();
			System.out.println("Creo nuovo "+dom[i]);
			if(v_serv.lastIndexOf(server)==-1) v_serv.add(server);
			
			domini.put(dom[i],v_serv);
			try {
				ks.add(cer);
				if(gest.verbose) System.out.println("aggiunto "+server);
			} catch(Exception e) {
				if(gest.verbose) System.out.println("non aggiunto "+server);
			}
		} 
		
	}
	/*
	private String[] risolviDominio(String dom) {
		System.out.println("risolvo Dominio "+dom);
		System.out.println("risolviDominio 1");
		Vector v_serv = (Vector) domini.get(dom);
		String[] resp = new String[v_serv ];
		
		System.out.println("risolviDominio 2");
		if(v_serv != null) {
			v_serv.copyInto(resp);
		} else return null;
		System.out.println("risolviDominio 3");
		System.out.println("risolvo Dominio "+dom+" : "+resp);
		return resp;
		
		
		
	}
	*/
	/*
	private synchronized void rimuoviDominio(String dominio) {
		Vector v_serv = (Vector) domini.get(domminio);
		if(v_serv != null) 
			if(v_serv.indexOf(dominio)==-1) {
				v_serv.remove(dominio);
			 	= new Vector();
		
	*/	
	/*
	public void insert(Vector server, String dom,Hashtable vpuk) {
	
		int len = server.size();
		Vector v_serv = (Vector) domini.get(dom);
		
		if(v_serv == null) v_serv = new Vector();
			//System.out.println("Creo nuovo "+dom[i]);
		for(int i = 0; i < len ;i++) {
			if(v_serv.lastIndexOf(server.get(i))==-1) v_serv.add(server.get(i));
			pkey.put(server.get(i),vpuk.get(server.get(i)));	
		
		
		}
		domini.put(dom,v_serv);
		
	}
	*/
	private Connessione connetti() {
		
		int len = s_server.size();
		String server;
		RSAPublicKey puk;
		Connessione con;
		for(int i=0;i<len;i++) {
			server = (String) s_server.get(i);
			try {
				puk = (RSAPublicKey) ks.getPublicKeyByAddr(server);
				con = new Connessione(server,puk,gest.getPrivateKey(),gest.getMe());
				if(con.stato()) return con;
			} catch (Exception e) {
				
			}
			
		}
		return null;
					
				//   gestione statistiche  
		
	}
	
	private Connessione connetti(String dom) {
		
		Vector v_serv = (Vector) domini.get(dom);
		if(gest.verbose) System.out.println("Richiedo  Dom : "+dom);
		if (v_serv != null ) System.out.println("Vector :"+v_serv.toString());
		Connessione con;
		if(v_serv != null ) {
			int len = v_serv.size();
			String server;
			RSAPublicKey puk;
			for(int i=0;i<len;i++) {
				try {
					server = (String) v_serv.get(i);
					puk = (RSAPublicKey) ks.getPublicKeyByAddr(server);
					
					con = new Connessione(server,puk,gest.getPrivateKey(),gest.getMe());
					if(con.stato()) return con;
				} catch (Exception e) { }
			}
			return null;
			 
		} 
		else return connetti();
			//   gestione statistiche  
			
	}
	
       	private String connettiFigli(MultiConnessione mcon) {
       		
       		Vector figli = new Vector();
		//Hashtable hdom = sc.getServer();
		int i,len,len1,h;
		String ser;
		boolean ce;
		for (Enumeration u = domini.keys() ; u.hasMoreElements() ;) {
			
	         		String g = (String)u.nextElement();
	         		Vector v = (Vector) domini.get(g);
	         		len = v.size();
	         		for(i=0;i<len;i++) {
	         			len1=figli.size();
	         			ser = (String) v.get(i);
	         			ce = false;
	         			for(h=0;h<len1;h++) if(ser.equals(figli.get(h))) ce = true;
	         			if(!ce) figli.add(ser);
	         			
	         		}
	         		
	         		
	         		
	         	}
	         	len1=figli.size();
	         	len = len1;
	         	if(gest.verbose) System.out.println("figli"+figli); // togli
	         	//iaik.utils.Util.waitKey();
	         	String server;
	         	RSAPublicKey puk;
	         	Connessione con;
	         	for(i = 0;i<len1;i++) {
	         		try {
		         		server = (String)figli.get(i);
					puk = (RSAPublicKey) ks.getPublicKeyByAddr(server);
					con = new Connessione(server,puk,gest.getPrivateKey(),gest.getMe());
					if(!con.stato()) len--;
		         		mcon.add(con);
		         	} catch (Exception e) { }
	         		
	         	}
	       		return "Attivata-"+len+"/"+len1;
       	}
	private String GetPubbl()  {
       		try {
			if(gest.verbose) System.out.println("GetPubbl");
			
			
			MyCertificate cert = (MyCertificate) mySock.leggi();
			String iniz = (String) mySock.leggi();
			String[] dom = (String[]) mySock.leggi();
			if(cert==null) {
				if(gest.verbose) System.out.println("certificato nullo");
				return "cert nullo";
			}
			
			if(!verificaFirmaCertificato(mySock.getFirma(),cert))
				return "NonValido";
			System.out.println("verifica di : "+cert.getAddress()+" "+verificaAlCertificatore(cert));
							
			
			if(gest.verbose) System.out.println("Domini");
			int len = java.lang.reflect.Array.getLength(dom);
			if(gest.verbose) for(int i=0;i<len;i++) System.out.println("	"+dom[i]);
			if(!iniz.equals(gest.getMe())) {
				insert(dom,cert);
				if(gest.verbose) System.out.println("Inseriti");
				salvaDomini();
				SetPubbl(dom,iniz);
				return "Inserito-"+cert.getAddress();
			} else {
				if(gest.verbose) System.out.println("Loop");
				return "Loop-"+cert.getAddress();
			}
			
			
				
		} catch (Exception e) {
       			if(gest.verbose) System.out.println("Non riesco ad importare i domini"+e.getMessage());
       			return "Errore";
       		}
       	}
	
	/*  NOTA pubblica i domini */
	private void SetPubbl(String[] dom,String iniz) {
		
		//int len =java.lang.reflect.Array.getLength(dom);
		if(!(s_server.isEmpty()||muto)) {
			int len =s_server.size();
			String server;
			RSAPublicKey puk;
			Connessione con;
			for(int i=0;i<len;i++) {
				try{
					
					server = (String) s_server.get(i);
					puk = (RSAPublicKey) ks.getPublicKeyByAddr(server);
					if(puk==null) System.out.println("chiave publica "+server+" nulla");
					System.out.println("Esporto "+gest.getIp()+" "+gest.getStringPort()+" a "+server+" ");
					con = new Connessione(server,puk,gest.getPrivateKey(),gest.getMe());
					if(con.stato()) {
						con.firma(gest.getMe());
						//System.out.println("firmato");
						con.manda("Pubbl");	
						con.manda(gest.getCertificate());
						con.manda(iniz);
						if(gest.verbose) System.out.println("mandato certif");
						con.manda(dom);
						// RIMETTERE con.mandacriptato();
						con.mandachiaro();
						if(gest.verbose) System.out.println("mandato tutto");
					}
					else if(gest.verbose) System.out.println("Conessione di setpubl non attiva");
				} catch(Exception e) {
					if(gest.verbose) System.out.println("Errore nel esportare i domini "+e.getMessage());
					
				}
				/* gestione statistiche */
			}
		} else { if(gest.verbose) System.out.println("Non esporto a super server "+s_server); }
		
       	}
       	private String verificaAlCertificatore(MyCertificate cert) {
       		if (!verificaCertificato(cert)) return "CerificatoNonValido";
       		RSAPublicKey keyc = (RSAPublicKey) ks.getCertificateByAddr(certAddr).getPublicKey();
       		Connessione con = new Connessione(certAddr,keyc,gest.getPrivateKey(),gest.getMe());
		if(con.stato()) {
			//con.firma(gest.getMe());
			con.manda("Cert");	
			con.manda(cert.getEncoded());
			con.mandachiaro();
			con.leggicriptato();
			Object l = con.leggi();
			
			if(con.stato()) {
				Firma fir = con.getFirma();
				if(fir !=null) {
					if(!verificaFirmaByAddr(fir,certAddr))
						return "FirmaNonValida";
				}else return "RispostaNonFirmata";
				try {
			
					String resp = (String) l;
					return resp;
			
				} catch(Exception e) {
					return "RispostaNonValida";
				}
			}else {
				return "CertificatoreNonPronto";
			}
			
			
		} else {
			if(gest.verbose) System.out.println("connessione certif non pronta");;
			return "CertificatoreNonPronto";			 
		}
       		
       			
       			
       		
       	}
       	private boolean verificaFirmaCertificato(Firma firma,MyCertificate cert) {
       		if (!verificaCertificato(cert)) return false;
       		RSAPublicKey pukx = (RSAPublicKey) cert.getPublicKey();
       		if (!verificaFirma(firma,pukx)) return false;
       		return true;
       			
       			
       		
       	}
       	private boolean verificaCertificato(MyCertificate cert){
       		try {
       			cert.verify(certkey);
       			return true;	
       			
       		} catch(Exception e) {
       			if(gest.verbose) System.out.println("errore verificaCertificato "+e.getMessage());
       			return false;
       		}
       	}
       	private boolean verificaFirma(Firma firma,RSAPublicKey pukx){
       		try {
       			String user = firma.getUser();
       			if(firma.verifica(pukx))
       				if(gest.getMe().equals(firma.getTo())) return true;
       			return false;
       		}
       		catch(Exception e){
       			if(gest.verbose) System.out.println("errore verificaFirma "+e.getMessage());       			
       			return false;
       			
       		}	
       		
       	}
	private boolean verificaFirmaByAddr(Firma firma,String addr){
       		
       		RSAPublicKey xxx = (RSAPublicKey) ks.getCertificateByAddr(addr).getPublicKey();
       		return verificaFirma(firma,xxx);
       		
       	}
}

