package servizi;

import java.sql.*;
import java.net.*;
import java.io.*;
import java.awt.*;

import java.util.*;
import iaik.security.rsa.*;
import java.security.*;
import java.security.spec.*;


import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;
import Gestore_Connessione;
import ServiceHash;
import TickTable;
import Ticket;


public class ServTicket extends Servizio {
	private TickTable ticktable; //cambia
	
	public ServTicket() {
		super();
		descrizione = "Servizi di risposta accesso con ticket";
		nome = "ServTicket";
		servizi = new String[2];
		servizi[0] = "Inizio";
		servizi[1] = "Client";
		servTerm = new String[1];
		servTerm[0] = "StampaTic, , stampa gli utenti che hanno richiesto una sessione";
			
	}

	public String risposta(String nomeserv,Object arg) {
		
		if(nomeserv.equals("Inizio")&&connesso) { 
			return inizio();
		
		}
		if(nomeserv.equals("Inizio")&&argomenti) { 
			byte[] tick;
			String ip;
			try {
				Object[] aaa = (Object[]) arg; 
				tick = (byte[]) aaa[0];
				ip = (String) aaa[1];
				
				return aggiungiTicket(tick,ip);
							
			} catch(Exception e) {
		              		return "ErroreArgomenti";
		             
		        }
			
			
		}
		if(nomeserv.equals("Client")) { 
			return clientAccess();
			
		}
		 
	    
		return "0";
	}
	
	public String rispostaTerminale(String nomeserv,String arg) {
		if(nomeserv.equals("StampaTic")) {
			String ret = "";
			ret = ticktable.stampaTic();
			if(ret.equals("")) return "Non ho ticket";	
			else return ret;
			
		}
		return null;
	
	}
	
	public void inizializza(Gestore_Connessione g,ServiceHash sh) {
		// da ridefinire se la serializzazione prevede cose particolari
		gest = g;
		servHash = sh;
		ticktable = new TickTable();
	}
	public void azzera() {
		// da ridefinire se la serializzazione prevede cose particolari
		gest = null;
		servHash = null;
		ticktable = null;
	}
	
	private String inizio() {
		byte[] tick;
		try {
			tick = (byte[]) mySock.leggi();
			String ip = (String) mySock.leggi();
			
			String res = aggiungiTicket(tick,ip);
			mySock.manda("ok");
			mySock.mandachiaro();
			if(gest.verbose) System.out.println("Mandata conferma ricezione di ticket ");
			
			return res;
		
		} catch(Exception e) {
	              		if(gest.verbose) System.out.println("Error ServTicket inizio"+e.getMessage());
	              		mySock.manda("Error");
			mySock.mandachiaro();
			return "-1";
	             
	        }
			
	}
	private String aggiungiTicket(byte[] tick,String ip) {
				
		Ticket ticket = new Ticket();
		ticket.inizializza(tick,gest.getPrivateKey());
		
		
		ticktable.insert(ip,ticket);
		if(gest.verbose) System.out.println("aggiunto ticket su ip "+ip);
		return "TicketAggiunto-";
	}
	private String clientAccess() {
       		Ticket[] tickvec = ticktable.get(mySock.ip());
       		int len;
       		if(tickvec!=null) len = java.lang.reflect.Array.getLength(tickvec);
       		else len = 0;
       		if(gest.verbose) System.out.println("tentativi da fare "+len);
       		boolean ok = false;
       		int i = 0;
       		while((!ok)&(i<len)) {
       			if(gest.verbose) System.out.println("prova accesso "+i);
       			mySock.inizio(tickvec[i].getKsessiontgs());
       			ok = mySock.leggiDesCriptato();
       			if (!ok) i++;	
       			
       		}
       		if(ok) {
       			byte[] tick;
       			String usr;
       			try {
	       			tick = (byte[]) mySock.leggi();
	       			usr = (String) mySock.leggi();
	       			mySock.inizio(tickvec[i].getKsessiontgs());
	       		} catch(Exception e) {
	            		if(gest.verbose) System.out.println("Error ServTicket clientaccess "+e.getMessage());
	              		return "-1";
	             
	        	}
	       		if(ticktable.verifica(mySock.ip(),usr,tick,tickvec[i])) {
	       			return servizi();
	       		} else {
	       		
				mySock.inizio(tickvec[i].getKsessiontgs());	
				mySock.manda("Error");	
				mySock.manda(usr);
				mySock.manda("Ticket non valido");
				mySock.mandaDesCriptato();
				return "TicketNonValido";
			}
       		} else {
       			//chiave non riconosciuta	
       			if(gest.verbose) System.out.println("chiave non riconosciuta");
       			return "ChiaveNonRiconosciuta";
       			
       		}
       	
	}
	private String servizi() {
			String str;
			try {
				str = (String) mySock.leggi();
				str = gestRic.attiva("TermRemoto",str,null);
				
			
			} catch(Exception e) {
				str = "ComandoNonRiconosciuto";
			}
			if(gest.verbose) System.out.println(" Risposta a comando : "+str);
			mySock.manda("respo");	
			mySock.manda(str);
			mySock.manda("Ticket valido");
			mySock.mandaDesCriptato();
			return "AccessoUtente";

	
	}
}