

import java.net.Socket;
import java.net.ServerSocket;
import java.io.*;
import java.util.*;
import java.security.*;

public class ServiceClassLoader extends SecureClassLoader {
	private String root;
	public ServiceClassLoader () {
		super();
		root = "servizi";
		
	}

	protected Class loadClass (String name, boolean resolve) throws ClassNotFoundException {

    // Since all support classes of loaded class use same class loader
    // must check subclass cache of classes for things like Object

		Class c = findLoadedClass (name);
		if (c == null) {
			try {
				c = findSystemClass (name);
			} catch (Exception e) {
			}
		}

		if (c == null) {
		// Convert class name argument to filename
		// Convert package names into subdirectories
			String filename = name.replace ('.', File.separatorChar) + ".class";
			//String filename = name.concat(".class");
			try {
				byte data[] = loadClassData(filename);
				c = defineClass (name, data, 0, data.length);
				if (c == null)
		 			throw new ClassNotFoundException (name);
			} catch (IOException e) {
				throw new ClassNotFoundException ("Error reading file: " + filename);
			}
		}
		if (resolve)
			resolveClass (c);
		return c;
	}
	private byte[] loadClassData (String filename) throws IOException {
		System.out.println("leggo in : "+filename);
		// Create a file object relative to directory provided
		File f = new File (filename);
		
		// Get size of class file
		int size = (int)f.length();
		System.out.println("lunghezza file :"+size);
		// Reserve space to read
		byte buff[] = new byte[size];
		
		FileInputStream fis = new FileInputStream(f);
		DataInputStream dis = new DataInputStream (fis);
		
		dis.readFully (buff);
		
		dis.close();
		
		return buff;
	}
	protected PermissionCollection getPermissions(CodeSource codesource) {
	
		System.out.println(" sorgente : "+codesource.getLocation());	
		return null;
		
		
	}
}