

import java.net.Socket;
import java.net.ServerSocket;
import java.io.*;
import java.util.*;
import java.security.*;
import servizi.*;
import GestRichieste;


public class ServiceHash {
	private Hashtable lisEventi;
	private Hashtable servnome;
	private Hashtable servizio;
	private ServiceClassLoader scl;
	Gestore_Connessione gest;
	
	public ServiceHash(Gestore_Connessione g) {
		servnome = new Hashtable();  // memorizza il nome servizio e il nome server
		servizio = new Hashtable();  // memorizza il nome server e il server
		lisEventi = new Hashtable();
		gest = g;
		scl = new ServiceClassLoader();
			
		try {
		       	scl.loadClass("servizi.Servizio");
		} catch(Exception e) {
	        	System.out.println("eccezione  : "+e.getMessage());
	        }	
		
		
	}
	public void registra(Servizio ser) {
		ser.inizializza(gest,this);
		aggiorna(ser);
		GestRichieste g = new GestRichieste(gest,this,ser);
		g.start();
		//String ev = ser.autoEsegui();
	}
	public void registraAgent(Servizio ser) {
		ser.inizializza(gest,this);
		GestRichieste g = new GestRichieste(gest,this,ser);
		g.start();
		//String ev = ser.autoEsegui();
	}
	public void aggiorna(Servizio ser) {	
		String nome = ser.nome();
		Servizio servecchio = (Servizio) servizio.get(nome);
		
		if(servecchio!=null) {
			System.out.println("servizio sovrascritto");
			ser.compra(servecchio.vendi());	
			
		} else System.out.println("servizio vecchio non trovato");
		
		String[] servizi = ser.pubblica();
		int num = java.lang.reflect.Array.getLength(servizi);
		System.out.println("servizi "+nome+" "+num);
		for(int i = 0; i<num ; i++) servnome.put(servizi[i],nome);
		//  metti i metodi per registrare i comandi da terminale  //
		
		//String sserv = ser.gestEventi();
		servizi = ser.eventi();
		num = java.lang.reflect.Array.getLength(servizi);
		System.out.println("registro eventi "+nome+" "+num);
		for(int i = 0; i<num ; i++) {
			// il comando deve essere nome_server,comando,argomenti,descrizione
			System.out.println("	registro "+servizi[i]);
			registraEvento(nome,servizi[i]);
		}
		GestRichieste g_r;
		
		if(servizio.put(nome,ser) == null) {
			//gestioneEvento("registra-"+nome+"-NonRegistrato");
			//g_r = new GestRichieste(gest,this,"ServHash-"+nome+"-NonRegistrato");
			//g_r.start();
		}else {
			//gestioneEvento("registra-"+nome+"-Registrato");
			//g_r = new GestRichieste(gest,this,"ServHash-"+nome+"-Registrato");
			//g_r.start();
		}
		
		
	}
	public boolean elimina(String ser) {
		      		
	         	Servizio sv = (Servizio) servizio.get(ser);
	         	if (sv != null) {
	         		for (Enumeration u = servnome.keys() ; u.hasMoreElements() ;) {
			
		         		String g = (String)u.nextElement();
		         		if(ser.equals((String) servnome.get(g))) servnome.remove(g);
	         		}
	         		for (Enumeration u = lisEventi.keys() ; u.hasMoreElements() ;) {
	         			String g = (String)u.nextElement();
		         		if(ser.equals((String) lisEventi.get(g))) lisEventi.remove(g);
	         		}
	         		sv.rimuovi();
	         		servizio.remove(ser);
	         		System.out.println("rimuovo "+ser);
	         		GestRichieste g_r = new GestRichieste(gest,this,"ServHash-"+ser+"-Eliminato");
				g_r.start();
	         		//gestioneEvento("Elimina-"+ser+"-Eliminato");
	         		return true;
	         	} else {
	         		//gestioneEvento("Elimina-"+ser+"-NonEliminato");
	         		GestRichieste g_r = new GestRichieste(gest,this,"ServHash-"+ser+"-NonEliminato");
				g_r.start();
	         	}
         		return false;
		
	}
	
	public void salvaServizio(String nome) {
		salvaServizio((Servizio) servizio.get(nome));
		
	}
	public void salvaServizio(Servizio ser1) {
		try {
			Servizio ser = ser1.mioClone();
			ser.azzera();
			FileOutputStream ostream = new FileOutputStream(new File("servizi",ser.nome()+".ser"));
			ObjectOutputStream p1 = new ObjectOutputStream(ostream);
			p1.writeObject(ser);
			p1.flush();
			ostream.close();
			GestRichieste g_r = new GestRichieste(gest,this,"ServHash-"+ser1+"-Salvato");
			g_r.start();
			//gestioneEvento("ServHash-"+ser1+"-Salvato");
		} catch(Exception e) {
			//gestioneEvento("Salva-"+ser1+"-NonSalvato");
			GestRichieste g_r = new GestRichieste(gest,this,"ServHash-"+ser1+"-NonSalvato");
			g_r.start();
		}
		
	}
	public void caricaServizio(String nome) {
		try {
			
			System.out.println("carico : "+nome);
				
					
			Servizio temp = (Servizio) scl.loadClass("servizi."+nome).newInstance();
         			temp.inizializza(gest,this);
			aggiorna(temp);
			//registra(temp);		
			//aggiorna(temp);
					
				
			
			
		} catch(Exception e) {
			/*
			try {
				System.out.println("Caricato da file servizi1");
				FileInputStream fis = new FileInputStream(new File("servizi",nome+".ser"));
				System.out.println("Caricato da file servizi2");
			        	ObjectInputStream ois = new ObjectInputStream(fis);
			        	System.out.println("Caricato da file servizi3");
				Object temp1  = (Object) ois.readObject();
				//Servizio temp  = (Servizio) ois.readObject();
				System.out.println("Caricato da file servizi4");
				fis.close();
				System.out.println("Caricato da file servizi4");
				Servizio temp = (Servizio) temp1;
				temp.inizializza(gest,this);
				System.out.println("Caricato da file servizi5");
				aggiorna(temp);
				System.out.println("Caricato da file servizi/"+nome+".ser");
				gestioneEvento("Carica-"+nome+"-Caricato");
			
			} catch(Exception ee) {
				System.out.println("Errori in carica "+ee.getMessage());
			*/
				//gestioneEvento("Carica-"+nome+"-NonCaricato");
				GestRichieste g_r = new GestRichieste(gest,this,"ServHash-"+nome+"-NonCaricato");
				g_r.start();
			//}

		}
		
	}
	
	public String[] nomiServ() {
		String[] ret = new String[servizio.size()];
		int i = 0;
		for (Enumeration u = servizio.keys() ; u.hasMoreElements() ;) {
			
         		ret[i++] = (String)u.nextElement();
         		
         	}
		
		return ret;
		
	}
	public synchronized Servizio richiedi2(String nomeserv) {
		String serv = (String) servnome.get(nomeserv);
		if (serv == null) {
			return null;
			
		} else {
			Servizio sv = (Servizio) servizio.get(serv);
			if (sv == null) {
				return null;
			
			} else {
				return sv.mioClone();
			}
		}
	}
	public synchronized Servizio richiediEvento2(String evento) {
		System.out.println("evento :"+evento);
		//try {
			String serv = eventoRegistrato(evento);
			if(serv != null) {
				Servizio sv = (Servizio) servizio.get(serv);
				if (sv == null) {
					return null;
			
				} else {
					return sv.mioClone();
				}
				
			}else {
				return null;
			}
		//} catch(Exception e) {
		//	System.out.println("Errore nella gestione evento :"+evento);
		//	return null;
		//}
	}
	public Servizio richiediServ(String serv) {
		return (Servizio) servizio.get(serv);
	}
	/*
	public String richiedi(String nomeserv,Object arg,Connessione s) {
		String serv = (String) servnome.get(nomeserv);
		Servizio sv;
		System.out.println("Richiesto "+nomeserv+" risponde "+serv);
		String ev;
		String n;
		if (serv == null) {
			ev = "nondispo";
			n = ev;
			
		} else {
			sv = (Servizio) servizio.get(serv);
			Servizio svc = sv.mioClone();
			ev = sv.rispondi(nomeserv,arg,s);
			n = sv.nome();
		}

		// ev = sv.rispondi(nomeserv,arg,s);

		gestioneEvento(n+"-"+nomeserv+"-"+ev);
		return ev;
	} 
	*/
	private String stampaServ(String s) {
		String ret = "";
 		Servizio sv = (Servizio) servizio.get(s);
 		ret = ret.concat("---\n");
 		ret = ret.concat(s+"  "+sv.descrizione()+"\n");
 		for (Enumeration u = servnome.keys() ; u.hasMoreElements() ;) {
			
         		String g = (String)u.nextElement();
         		if(s.equals((String)servnome.get(g))) {
         			ret = ret.concat("    "+g+"\n");
         		}
         	}
         	return ret;
	}	
	public String stampaServizi(String arg) {
		String ret = "";
 		int i = 0;
		for (Enumeration e = servizio.keys() ; e.hasMoreElements() ;) {
			String s = (String)e.nextElement();
			//System.out.println("Stampo Servizio ?"+arg+" "+s);
			if(s.equals(arg)||arg.equals("")) {
				ret = ret.concat(stampaServ(s));
				i = i + 1;
			}
         	}
         	if(arg.equals("")) {
         		//gestioneEvento("stampa-all-"+i);
			GestRichieste g_r = new GestRichieste(gest,this,"ServHash-all-"+i);
			g_r.start();
         	}
         	else {
         		//gestioneEvento("stampa-"+arg+"-"+i);
         		GestRichieste g_r = new GestRichieste(gest,this,"ServHash-"+arg+"-"+i);
			g_r.start();
         	}
         	return ret;
	} 
	/* gestione eventi
		un evento  sempre con un .1 o .0 finale .1 sempre .0 solo il primo 
		servizio.sottoservizio.evento.X       [X = 0,1]  solo l' evento
		servizio.sottoservizio.all.X       tutti gli eventi del sottoservizio
		servizio.all.all.X       tutti gli eventi di tutti i sottoservizi
		
		
		Ho eventi particolari quali
		Confl.Y.Z un sottosevizio Y si registra permanentemente sotto lo stesso evento permanente di Z
		 Y  eliminato 
		TConfl.Y.Z un sottosevizio Y si registra permanentemente sotto lo stesso evento temporaneo di Z
		 Y  eliminato
		Sovr.Y.Z un sottosevizio Y si registra temporaneamente sotto lo stesso evento permanente di Z
		
		TSovr.Y.Z un sottosevizio Y si registra permanentemente sotto lo stesso evento temporaneo di Z
		
		
		
		N.B.  Se due servizi si registrano uno per Ser1.all.all
			e l'altro per Serv1.sottoserv1.all   non sono in conflitto
	
		registra.Servizio.0 o .1 0 se non c'era 1 se l'ho sostituito
		elimina.Servizio.0 o .1
		stampa.all.num    num  il numero di servizi
		stampa.servizio.num   se ho richiesto un servizio particolare
		salva.Servizio.0 o .1
		carica.Servizio.0 o .1
	
	*/
	public void registraEvento(String nome, String evento) {
		String eve = evento.trim();
		boolean zero = eve.endsWith("-0");
		boolean uno = eve.endsWith("-1");
		int len = eve.length();
		int num = 0;
		for(int i = 0; i<len ; i++) {
			if(eve.charAt(i) == '-') num++;	
		}
		if ((num == 3)&&(len>6)) {
			eve = eve.substring(0,len-2);
			
			boolean temp = lisEventi.containsKey(eve.concat("-0")); 
			boolean perm = lisEventi.containsKey(eve.concat("-1")); 
			String svpass = (String) lisEventi.put(evento.trim(),nome);
			if(svpass != null ) {
				String svpassX="";
				if(perm&&uno) svpassX ="Confl-"+nome+"-"+svpass; //lancia eve Confl
				if(temp&&uno) svpassX ="TConfl-"+nome+"-"+svpass; // lancia eve TConfl
				if(temp&&zero) svpassX ="Sovr-"+nome+"-"+svpass;  //lancia eve Sovr
				if(perm&&zero) svpassX ="TSorv-"+nome+"-"+svpass; //lancia eve TSovr
				GestRichieste g_r = new GestRichieste(gest,this,svpassX);
				g_r.start();
				
			}
		}	
	}
/*
	public void gestioneEvento(String evento) {
		System.out.println("evento :"+evento);
		try {
			String serv = eventoRegistrato(evento);
			if(serv != null) {
				Servizio sv = (Servizio) servizio.get(serv);
				System.out.println("gestione evento :"+evento+" servizio : "+serv);
				sv.gestEventi(evento);	
				
			}
		} catch(Exception e) {
			System.out.println("Errore nella gestione evento :"+evento);
			
		}
		
		
	}
*/
	public void togliEvento(String evento) {
		lisEventi.remove(evento);
		
	}
	public String eventoRegistrato(String evento) {  //restituisce il servizio
		String eve = evento.trim();
		//System.out.println("cerco eventoRegistrato :"+eve);
		int h = -1,num = 0;
		int len = eve.length();
		for(int i = 0; i<len ; i++) {
			if(eve.charAt(i) == '-') {
				num++;
				if(num == 3) h = i;	
			}
		}
		if(h!=-1) {
			
			eve = eve.substring(0,h);	
			
		}
		String sv = controllaEvento(eve);
		if(sv == null) {
			int pun = eve.lastIndexOf("-");
			if(pun<0) return null;
			String ev1 = eve.substring(0, pun); 
			sv = controllaEvento(ev1.concat("-all"));     //guardo se  registrato per tutti gli eventi del sottoservizio
			if(sv == null) {
			
				int pun1 = ev1.lastIndexOf("-");
				String ev2 = ev1.substring(0, pun1); 
				sv = controllaEvento(ev2.concat("-all-all")); //guardo se  registrato per tutti i servizi del servizio
				if(sv == null) return null;
				else {
					return sv;
					
				}
			}
			else {
				return sv;
				
			}
		} else {
			return sv;
			
		}
	}
	private String controllaEvento(String evento) {
		// restituisce 0servizio o 1servizio o null
		//System.out.println("controlla evento : "+evento);
		boolean cancella = true;
		String sv = (String) lisEventi.get(evento.concat("-0"));  
		if(sv == null) {
			sv = (String) lisEventi.get(evento.concat("-1"));
			cancella = false;
		} else togliEvento(evento.concat("-0"));
		if(sv != null) {
			return sv;
			// if(cancella) return new String("0"+sv);
			// else return new String("1"+sv);
		} else return null;
		
	}
		
}
/*
class MyClassLoader extends SecureClassLoader {
        

         public Class findClass(String name) {
             byte[] b = loadClassData(name);
             return defineClass(name, b, 0, b.length);
         }

         private byte[] loadClassData(String name) {
             // load the class data from the connection
             
         }
}
*/

