package servizi;

import java.net.Socket;
import java.net.ServerSocket;
import java.io.*;
import java.util.*;

import Gestore_Connessione;
import ServiceHash;
import Connessione;
import GestRichieste;


abstract public class Servizio implements Serializable, Cloneable{
	
	protected String[] servizi;
	protected String[] servTerm;
	protected String[] eventi;
	//protected String gestEventi;
	protected String nome;
	protected String descrizione;
	protected Gestore_Connessione gest;
	protected GestRichieste gestRic;
	protected ServiceHash servHash;
	protected Connessione mySock;
	protected boolean RSAcriptato;
	protected boolean DEScriptato;
	protected boolean chiaro;
	protected boolean firmato;
	protected boolean criptato;
	protected boolean connesso;
	protected boolean argomenti;
	
	protected Servizio() {
		servTerm = new String[0];
		servizi = new String[0];
		eventi = new String[0];
		//gestEventi = "";
	}
	
	public void nuovoGest(GestRichieste gr) {
		gestRic = gr;
	}
	
	public String[] pubblica() {
		return servizi;
		
	}
	public Servizio mioClone() {
		try {
			Servizio sv = (Servizio) clone();
			return sv;	
		} catch (Exception e) {
			return null;
		}
	}
	public String[] terminale() {
		// il comando deve essere comando,argomenti,descrizione
		return servTerm;
		
	}
	public String rispostaTerminale(String comando,String arg) {
		return null;
		
	}
	public String[] eventi() {
		// devo restituire
		return eventi;
		
	}
	public String gestEventi(String ev) {
		// devo restituire
		return ev;
		
	}
	
	public String descrizione() {
		return descrizione;
		
	}
	protected void inizializza_p(Gestore_Connessione g,ServiceHash sh) {
		// inizializzazione del servizio
		// da ridefinire se la inizializzazione prevede cose particolari
		gestRic = null;
		gest = g;
		servHash = sh;
		
	}
	protected void azzera_p() {
		gestRic = null;
		gest = null;
		servHash = null;
		mySock = null;
	}
	
	public void azzera() {
		// azzero il servizio
		// da ridefinire se l' azzeramento prevede cose particolari
		azzera_p();
		
	}
	public String nome() {
		return nome;
	}
	public void inizializza(Gestore_Connessione g,ServiceHash sh) {
		// inizializzazione del servizio
		// da ridefinire se la inizializzazione prevede cose particolari
		inizializza_p(g,sh);
		
	}
	public Object vendi() {
		// da ridefinire se il mirroring prevede cose particolari
		return null;
	}
	public void compra(Object o) {
		// da ridefinire se il mirroring prevede cose particolari
		
	}
	public void prepTrasporto() {
		// serve per preparare il Servizio al trasporto
		// da ridefinire se la compattazione prevede cose particolari
		azzera_p();
	}
	public void riprTrasporto(Gestore_Connessione g,ServiceHash sh) {
		// serve per ripristinare il Servizio dal trasporto
		// da ridefinire se il ripristino prevede cose particolari
		inizializza_p(g,sh);
	}
	public void rimuovi() {
		// da ridefinire se la rimozione prevede cose particolari
		
	}
	public String autoEsegui() {
		// da ridefinire se l'attivazione prevede esecuzione automatica
		return null;
	}
	public String rispondi(String nomeserv,Object arg,Connessione s){
		RSAcriptato = false;
       		DEScriptato = false;
       		chiaro = false;
       		firmato = false;
       		connesso = false;
		if(arg == null) argomenti=false;		
       		else argomenti=true; 	
		if(s!=null) { 
			mySock = s;
			connesso = true; 
			RSAcriptato = mySock.isRSAcriptato();
       			DEScriptato = mySock.isDEScriptato();
       			criptato = RSAcriptato | DEScriptato;
       			chiaro = mySock.isChiaro();
       			firmato = mySock.isFirmato();
       			
       		}
		else connesso = false;
		
		//System.out.println("rispondo "+nomeserv+" "+nome());
		return risposta(nomeserv,arg);
	}
	
	protected abstract String risposta(String nomeserv,Object arg);
	
		
	
}
